# HBuilder X - Release Notes
======================================
## 0.1.50.20180918-alpha
* 【uni-app插件】
	+  优化 下拉刷新配置
	+  修复 uploadFile 参数 files 不生效
	+  修复 组件内联 style 中使用 background-image 相对路径不生效
	+  修复 组件 picker-view 无法正确选中
    +  修复 部分历史创建的uni-app项目在iOS平台真机运行报错的bug
    +  修复 模板 索引列表在微信小程序平台，滑动右侧索引导致整体界面跟随滑动的bug

## 0.1.49.20180917
* 新增 设置提供可视化界面
* 调整 插件配置统一汇总到菜单【工具】-【插件配置】，所有插件包括内置的格式化插件jsbeaufy配置都调整到此入口
* 新增 Prettier插件，处理less、scss、php文件格式化
* 修复 插件安装后可能导致外部命令无法显示的问题
* 新增 wap2app 项目创建、打包、manifest可视化
* 新增 菜单文件-打开历史文件，支持打开历史项目
* 优化 全部保存的快捷键默认为【Ctrl+Alt+s】
* 修复 html的text区域无法输入中文书名号的问题。可选择是否转义
* 修复 光标在文件开头时格式化造成HBuilderX无响应的问题
* 修复 项目名称包含空格时代码助手图片预览失效的问题
* 优化 删除目录时该目录下已打开的文件自动关闭
* 优化 文件和文件夹内搜索过滤unpackage目录
* 修复 markdown 大纲层级不正确的问题
* 优化 运行菜单，在toolbar上点运行和Ctrl+r运行，统一下拉运行菜单。等待手机检测时可反复按Ctrl+r。点击菜单运行很低效，推荐点击toolbar或快捷键
* 修复 有时打包失败没有提示错误信息的问题
* 优化 真机运行崩溃的问题
* 修复 uni-app 编译添加node和npm环境变量，以免因为npm和node不统一造成编译失败的问题
* 修复 uni-app 小程序运行后，切换项目后点控制台的停止按钮无法停止的问题
* 优化 uni-app manifest可视化界面新增微信小程序配置（注意app的sdk里的微信设置和微信小程序设置是不同的）
* 修复 uni-app 微信开发者工具启动后无法查看源码的问题
* 修复 uni-app 相同appid和projectName时无法启动微信开发者项目的问题
* 修复 uni-app 修改manifest.json时有可能导致崩溃的问题
* 【uni-app插件】
	+ 【重要】 新增 upx 作为响应式尺寸单位，px 变为传统的物理像素，历史项目升级参考 [教程](http://ask.dcloud.net.cn/article/35014)
	+ 新增 支持注册全局组件 [文档](http://uniapp.dcloud.io/use?id=%E5%85%A8%E5%B1%80%E7%BB%84%E4%BB%B6)
	+ 新增 pages.json app-plus 支持pullToRefresh配置 [文档](http://uniapp.dcloud.io/collocation/pages?id=下拉刷新)
	+ 优化 iOS平台 从UIWebview切换为WKWebview，提升页面图片渲染速度
	+ 新增 小程序平台 分包预下载（hello uni-app示例为方便分包调整了目录结构）
	+ 修复 css 变量 var(--status-bar-height) 部分情况不生效 
	+ 修复 组件嵌套 slot 无法传递 props
	+ 优化 组件 input 支持focus属性，自动弹出键盘（目前iOS部分版本仍有兼容问题）
	+ 优化 组件 input 支持confirm-type=search属性，键盘右下角显示为搜索样式
	+ 优化 组件 swiper 在iOS平台屏幕边缘的滑动体验
	+ 修复 uni.openLocation无法调用系统导航的问题
	+ 修复 iOS setNavigationBarColor 改变frontColor时未修改状态栏颜色
	+ 修复 组件 picker-view value属性不生效的bug
	+ 修复 页面onLoad事件内立即执行reLaunch不生效的bug
	+ 优化 back逻辑，优先关闭当前显示的 loading 或 toast，再关闭页面
	+ hello uni-app 新增 input 示例新增自动弹出键盘、搜索框
	+ hello uni-app 新增 侧滑导航示例
	+ hello uni-app 新增 多列选择、联动选择示例（含城市选择）
	+ hello uni-app 新增 自定义导航栏示例
	+ hello uni-app 优化 导航栏示例中App原生按钮的写法和样式
	+ hello uni-app 新增 load more（加载更多）示例
	+ hello uni-app 新增 segment control（分段选择器）示例
	+ hello uni-app 新增 indexed-list（索引列表）示例
	+ hello uni-app 新增 图片懒加载示例
	+ hello uni-app 新增 手势图片锁屏示例
	+ hello uni-app 新增 IM chat示例（感谢网友xcecd@qq.com）
* 【5+App插件】
	+ 新增 Webview窗口titleNView的按钮类型（type），内置支持"前进"、"后退"、"分享"、"收藏"、"主页"、"菜单"、"关闭"按钮图标
	+ 完善 直播推流（LivePusher）控件，可支持推流前显示预览（preview）摄像头画面
	+ 完善 Webview窗口下拉刷新支持通过WebviewStyles的pullToRefresh属性设置，添加"pullToRefresh"事件（下拉刷新时触发）
	+ 修复 微信登录授权可能存在的安全隐患，补充authorize方法获取授权code避免泄露appsecret数据
	+ Android平台 修复 云端打包自定义targetSdkVersion后可能无法获取定位信息的问题
	+ Android平台 修复 部分设备可能出现无法通过微信分享图片的问题
	+ Android平台 修复 视频播放控件timeupdate事件返回参数不正确的问题
	+ Android平台 修复 视频播放控件缓冲事件仅触发一次的问题
	+ Android平台 修复 视频播放控件全屏后可能显示虚拟键盘的问题
	+ Android平台 修复 Webview配置titleNView分割线可能不显示的问题
	+ Android平台 修复 地图resize后自动全屏显示的问题
	+ Android平台 修复 调用plus.runtime.launchApplication方法将应用激活到前台不触发newintent事件的问题（新增参数newTask控制）
	+ Android平台 修复 部分手机上可能出现二维码扫码崩溃的问题
	+ Android平台 修复 多点触摸滑动操作可能引起应用假死的问题
	+ iOS平台 新增 支持摄像头录像（plus.camera.startVideoCapture）设置视频长度（videoMaximumDuration）。Android视频录制时长控制请使用Native.js，[参考](http://ask.dcloud.net.cn/question/45756)
	+ iOS平台 新增 支持分别设置Webview窗口顶部（backgroundColorTop）和底部（backgroundColorBottom）的回弹区域背景颜色
	+ iOS平台 修复 视频播放控件不触发缓冲事件的问题
	+ iOS平台 修复 系统相册选择文件不支持gif图片的问题
	+ iOS平台 修复 原生View控件中使用富文本可能引起程序崩溃的问题
	+ iOS平台 完善 Webview下拉刷新控件支持配置雪花和文字颜色（"pullToRefresh":{"color":"#ff0000"}）
	+ iOS平台 修复 真机运行时可能出现数据（plus.storage.setItem）丢失的问题
	+ iOS平台 修复 模拟器运行可能出现JS异常错误的问题
	+ iOS平台 修复 使用WKWebview内核时页面中input无法主动设置焦点弹出软键盘的问题


## 0.1.48.20180906-alpha
* 【重要】新增 自动保存修改内容到临时文件的功能，停电、崩溃不再担心。这个机制不是保存正式文件，不会触发自动编译运行。自动保存间隔时间默认为30秒，可在设置里修改
* 新增 全部保存功能
* 新增 uni-app项目新建页面、组件的功能。新建页面会自动新建同名目录、vue文件及自动添加到pages.json最后
* 新增 在uni-app项目下打开的vue页面编辑器，右键添加转到pages.json对应节点的功能
* 优化 文件在外部被编辑后，提醒变更的逻辑
* 修复 git插件无法使用的问题
* 修复 拖动代码不能移动位置的问题
* 修复 黑色主题下，光标在括号旁边时，匹配括号的黑色小框看不清的问题
* 修复 js字符串中文字符转义的问题
* 修复 有些包含大量emoji字符的utf8文件编码识别错误的问题
* 修复 node插件升级时，如果已安装会重新安装的问题
* 修复 Ctrl+tab无法切换到预览文件的问题
* 修复 函数参数为function时不能自动补全圆括号的问题
* 修复 Mac上中文输入法有时出现多余字符的问题
* 修复 Mac上撤销操作偶发乱套的问题
* 调整 删除jshint校验js的逻辑，校验js请安装eslint插件
* 修复 真机运行菜单iOS设备的中文显示为乱码的问题
* 修复 真机运行菜单正在运行的设备对应的项目名称有可能显示不对的问题
* 修复 真机运行多个设备时有时候出现不同步文件的问题
* 修复 App打包界面选择的iphone、ipad打包时不生效的问题
* 【uni-app插件】
	+ 更新 mpvue 相关插件至最新
    + 新增 小程序平台 分包加载，参考[pages.json配置说明](http://uniapp.dcloud.io/collocation/pages?id=subpackages)
    + 新增 TypeScript 预编译器支持，实现了 <script lang="ts" src="xx.ts"></script> 引用方式的自动识别
    + 新增 内置 autoprefixer ，自动处理css兼容性(iOS>=8,Android>=4)，修复iOS8上部分组件变形的问题
    + 新增 App平台 二级页面支持单独取消原生导航栏，支持定义导航栏为透明渐变模式
    + 新增 组件 picker-view，规范参考[picker-view](http://uniapp.dcloud.io/component/picker-view)
    + 修复 uni.switchTab跳转的bug，注意switchTab跳转后会关闭所有非tabbar页面。可用于初始页为欢迎页、登陆页，之后switchTab到业务首页的场景
    + 修复 uni.request 未返回 header 的问题
    + 修复 组件 textarea 有时无法输入汉字的问题
    + 修复 组件 input 数字类型无法输入小数点的问题
	+ 修复 启动后立即切换tab，可能卡死的问题
    + hello uni-app 页面跳转 新增switchTab、reLaunch演示
    + hello uni-app 新增 EChart图标示例
    + hello uni-app 新增 可拖动九宫格示例
	+ hello uni-app 新增 自定义导航栏（透明渐变、自定义按钮）示例
	+ hello uni-app 优化 列表到详情模板 详情页改为透明渐变导航
    + hello uni-app 新增 图片、头像剪切示例（感谢网友杨大宝）
    + hello uni-app 新增 二维码生成示例（感谢网友诗小柒）
	+ 更多三方扩展，参考[http://ask.dcloud.net.cn/explore/category-12__is_recommend-1](http://ask.dcloud.net.cn/explore/category-12__is_recommend-1)
    + 新增 应用模板：图片浏览App模板
    + 新增 应用模板：登录注册模板
	+ 新增 [mpvue项目（组件）迁移指南、示例及资源汇总](http://ask.dcloud.net.cn/article/34945)
* 【5+App插件】
	+ 修复 Webview窗口创建后无法动态添加titleNView的问题
	+ Android平台 补充 录音支持aac音频格式文件
	+ Android平台 优化 打开较多窗口后可能导致窗口动画掉帧的问题
	+ Android平台 修复 微信小程序分享图片可能变虚的问题
	+ Android平台 修复 无法上传中文名文件的问题
	+ iOS平台 修复 模拟器不支持视频播放&直播推流控件的问题
	+ iOS平台 修复 等待框自定义高度时垂直方向没有居中的问题
	+ iOS平台 修复 微信分享可能不触发回调的问题
	+ iOS平台 修复 操作storage可能引起卡顿的问题
	+ iOS平台 修复 播放控件（VideoPlayer）不触发ended事件的问题
	+ iOS平台 修复 在iPhoneX获取状态栏高度不正确的问题
	+ iOS平台 修复 启用js原生混淆后使用Webview的appendJsFile方法失效的问题
	+ iOS平台 修复 启用js原生混淆后使用wgt升级后无法运行的问题
	+ iOS平台 优化 下拉刷新的样式改为与iOS邮件一致。下拉区域的背景色可在webviewStyle的bounceBackground设置
	+ iOS平台 修复 Webview窗口titleNView更新标题文字颜色后返回按钮颜色没有同步更新的问题

## 0.1.47.20180823-alpha
* 【uni-app插件】
	+ 修复 通过<style lang="less"></style>方式使用less、scss、stylus预编译语言开发，云端打包时编译报错的问题
* 【5+App插件】
	+ 修复 Android平台修复真机运行uni-app录制音频可能引起崩溃的问题
	
## 0.1.47.20180821-alpha
* 添加 uniapp编译前先进行manifest.json和pages.json的语法校验的功能
* 添加 真机运行控制台添加重启、停止、启动的功能
* 优化 真机运行控制台焦点切换的问题
* 优化 代码提示时uni-app下js模块提示过滤掉pages.json下配置的页面
* 修复 node插件升级失败有可能导致崩溃的问题
* 修复 通过点击“Android模拟器端口设计”菜单导致端口丢失的问题
* 修复 正则搜索卡死的问题
* 修复 外部命令报node不可运行
* 修复 真机运行编译器报错无法跳转到对应文件的问题
* 修复 真机运行编译器日志错乱的问题
* 修复 升级时有些node插件不安装的问题
* 修复 manifest图形编辑器设置iphonex、iphonexl启动图的节点名称不对的问题
* 修复 内置浏览器渲染进程异常导致崩溃的问题
* 修复 项目管理器中操作文件小概率崩溃的问题
* 修复 manifest.json文件末尾为注释会导致App打包进度一闪而过的问题
* 修复 manifest可视化编辑器编辑时可能损坏包含//注释的manifest.json文件内容结构的问题
* 修复 创建项目时关闭新建界面导致崩溃的问题
* 修复 App打Android包没有提交xxxhdpi图标的问题
* 修复 mac下移除项目到回收站有时会失败的问题
* 修复 使用emmet的时候按下tab键后中文乱码
* 【uni-app插件】
	+ 新增 支持vue里通过<style lang="less"></style>方式使用less、scss、stylus这3种预编译语言。需先在HBuilderX插件安装中安装对应编译插件
	+ 新增 pages.json 中 globalStyle, style 节点支持分平台配置，可在App侧单独定义titleNView。[参考pages.json说明](http://uniapp.dcloud.io/collocation/pages?id=app-plus)
	+ 新增 App中监听原生Title的按钮点击事件onNavigationBarButtonTap
	+ 优化 编译的错误日志提示语
	+ 补充 启动时指定关闭Splash的延时时间
	+ 新增 uni.canvasToTempFilePath，可把canvas区域保存为图片
	+ 支持 iPhone X 安全区域配置（默认：App 包含 tabBar 时，自动启用底部安全区域，背景色为 tabBar 背景色，无 tabBar 时，不启用安全区域。也可在App侧参考5+的manifest规范配置）
	+ 修复 非首页配置 navigationBarTextStyle 不生效
	+ 修复 组件 video show-play-center-btn 不生效
	+ 修复 组件 input 标签属性 value="" 导致运行时显示为 true
	+ 修复 组件 input 类型为 number 时输入报错
	+ 修复 组件 input 在 iOS 平台焦点错乱，快速输入异常，删除时光标错乱
	+ 修复 组件 input 数字类型输入非法字符时 placeholder 不消失
	+ 修复 组件 map 的 translateMarker 方法不生效
	+ 修复 uni.navigateBack delta 参数不生效
	+ 修复 uni.getSystemInfo/uni.getSystemInfoSync 返回 platform 不正确
	+ 修复 uni.reLaunch 参数丢失
	+ 修复 onLoad 事件内立刻调用 uni.startPullDownRefresh 不生效
	+ 修复 App 生命周期 onShow,onHide 在 app 切换到前台、后台不触发的问题
	+ 新增 新项目模板默认添加 mp-weixin->appid 节点
	+ hello uni-app：支持app端首页单独设置原生导航栏，并在右上角增加关于介绍按钮
	+ hello uni-app：新增 接口 媒体 文件示例
	+ hello uni-app：新增 模板 markdown渲染富文本（用于图文新闻、资讯、笔记快速渲染）
	+ hello uni-app：新增 模板 问题反馈
* 【5+App插件】
	+ 新增 视频播放控件支持视频长度（duration）、静音播放（muted）、是否显示视频中间的播放按钮（show-center-play-btn）等功能
	+ Android平台 修复 拍照后返回可能引起卡顿的问题
	+ Android平台 修复 系统等待框自定义Loading图片不支持相对路径的问题
	+ Android平台 修复 真机运行修改css/js可能无法同步刷新的问题
	+ iOS平台 补齐 支持不设置应用Splash图片时自动使用默认应用图标的开屏界面
	+ iOS平台 新增 支持设置录音声道（channels）功能，调整默认录音为单声道
	+ iOS平台 修复 使用高德地图后可能导致应用无法启动的问题
	+ iOS平台 修复 不支持设置iPhone5&6横屏开屏图片的问题

## 0.1.46.20180810-alpha
* 新增 5+app项目的manifest图形化编辑器
* 新增 iOS真机运行保存时自动刷新手机的功能
* 修复 网络被劫持时插件下载失败的问题
* 修复 mac下休眠一段时间后HBuilderX卡死的问题
* 修复 在资源管理器中双击文件或通过打开方式启动应用后有时无法打开对应文件的问题
* 修复 css文件行注释异常的bug
* 修复 settings.json文件不合法导致启动就弹错误提示框，并且界面主题混乱的问题
* 优化 App打包时支持隐藏进度界面
* 新增 移除项目到回收站的功能
* 新增 uni-app项目光标在标签语句上按F1可打开组件帮助文档
* 补充 用户登录后每天自动签到加社区积分功能
* 优化 windows下自动检测微信开发者工具所在目录
* 优化 vue代码提示，支持自定义组件的属性提示
* 优化 双引号自动补全时绿光标结束点的逻辑
* 修复 有时弹出错误的快捷键冲突选择菜单的问题
* 修复 php自定义代码块不生效的问题
* 修复 有时启动崩溃的问题
* 修复 光标选到页首时，注释、加粗、加包围等操作可能引发崩溃的问题
* 【uni-app插件】
	+ 修复 Android4.4、5.0的兼容问题
	+ 修复 不支持iOS模拟器的问题
	+ 优化 iOS上的运行性能，尤其是示例中模板tab示例的卡顿
	+ 升级 mpvue至1.0.13
	+ 修复 uniapp的appid为空时真机运行白屏的问题
	+ 优化 部分手机上splash关闭过早造成白屏的问题
	+ 新增 css变量var(—status-bar-height)，微信小程序固定为25px，App环境为真实状态栏高度，[详见](http://uniapp.dcloud.io/frame?id=css%E5%8F%98%E9%87%8F)
	+ 修复 pages.json修改page的style不编译的问题
	+ 优化 video组件从HTML5 video改为原生video
	+ 修复 解决大部分情况下，页面data数据未重置导致的页面显示旧数据
	+ 修复 reLaunch每次都会出现启动splash的问题
	+ 更新 对接最新的5+分享接口，支持小程序分享
	+ 修复 禁用 .babelrc 对编译器的影响
	+ 更新 扫码支持 onlyFromCamera、scanType 参数
	+ 修复 有时运行到微信模拟器未生成project.config.json的问题
	+ 优化 previewImage
	+ 优化 dns.js(localhost)报错提示
	+ 更新 调整App运行时的userAgent
	+ 更新 调整 input 组件数字输入，身份证输入，带小数点的数字键盘对应的类型
	+ hello uni-app：新增商品列表模板
* 【5+App插件】
	+ 新增 视频播放控件（plus.video.VideoPlayer）支持弹幕、设置全屏方向等功能
	+ 更新 微信分享SDK，新增支持分享音频、视频、**小程序**等
	+ 更新 新浪微博分享SDK，新增支持分享视频
	+ 更新 QQ分享SDK，新增支持分享音乐
	+ Android平台新增 不设置应用Splash图片时自动使用默认应用图标的开屏界面，取消大H Splash
	+ Android平台修复 Webview为子窗口时通过无法通过setStyle更新大小及位置的问题
	+ Android平台修复 获取文件信息（plus.io.File）返回的type类型不正确的问题
	+ iOS平台修复 真机运行同步刷新页面引起程序卡死/崩溃的问题
	+ iOS平台修复 百度地图无法显示内容的问题
	+ iOS平台修复 设置状态栏样式可能不生效的问题
	+ iOS平台修复 视频播放控件未设置自动播放时可能会自动播放的问题


## 0.1.45.20180728-alpha
* 【重要】新增uni-app，使用vue技术，开发一次，iOS、Android、微信小程序三端同时生成。[详见](http://uniapp.dcloud.io/)
* 【重要】调整uniapp策略，之前的原生渲染uniapp改为nml项目[详见](http://ask.dcloud.net.cn/article/13507)
* uni-app：新增条件编译，采用类似 //#ifdef APP-PLUS 的写法做平台条件编译，代码块名为ifdef，还可双击ifdef选中整体代码段落。[详见](http://uniapp.dcloud.io/platform)
* uni-app：新增u开头的各种组件和api的代码块，如urequest即可快速生成联网代码
* 【重要】语法校验
	+ 新增html,vue,css,sass,less等语法验证插件【安装插件后默认是保存时校验，也可在工具菜单手动激活】
	+ 优化语法校验，在代码中通过波浪线直接标识，支持F4跳转到下一个语法错误
	+ json文件保存时，自动删除多余错误逗号
* 【重要】新增光标在api代码处，按F1打开对应的帮助文档。目前支持uni-app、plus、vue的api
* 优化新建菜单，增加文件模板及自定义模板
* 新增切换最近文件列表。Win:Ctrl+Tab；Mac:Alt+Tab。短按是在最近2个标签卡切换，长按可在列表中持续移动（逻辑同OS的切屏）
* 新增文件收藏功能，方便快速访问常用文件【Alt+Shift+f】
* 新增快捷键冲突时弹出选择菜单的功能
* 代码提示
	+ 优化js中json语法的提示
	+ 修复翻页可能错乱的bug
	+ 补充vue指令的信息帮助及vuex框架语法库
	+ 修复某些情况下框架语法库失效的问题
* Emmet：修复在css、php等文件中失效的bug
* 优化代码块教程，新增clogvar快捷打印变量的js代码块
* 优化vue转到定义
* 智能回车
	+ json的键值对和数组后回车，自动补充行尾逗号
	+ 优化js中/**回车处理
	+ 修复回车时光标可能在屏幕外的问题
* 智能双击
	+ 新增双击逗号左侧或右侧，选中数组或参数的前一个或后一个。大幅提升json的节点增删效率
	+ 新增双击条件编译区的ifdef或endif关键字选中条件编译段落
	+ 新增双击行尾行注释，选中注释段
	+ 新增Alt+双击括号引号，把两侧的括号引号也选中
* 优化重复插入，不选内容时是重复插入当前行，选内容时是重复插入选区。Win:Ctrl+Insert；Mac:Command+Shift+r
* 优化缩进，支持空格、tab转换和长度调整，使用方式：菜单【编辑】-【缩进】
* 外部命令新增terminal类型，使用该类型的外部命令运行环境设定为内置终端
* 优化内置终端插件的使用体验
* 优化运行
	+ 支持多设备运行到不同的控制台
	+ 修复项目名含有+号等特殊字符时，无法在内置web服务器运行和预览的问题
	+ 修复Mac无法自动识别已安装的浏览器的问题
	+ 修复预览时web服务器启动慢导致无法使用web服务器预览的bug
* markdown
	+ 粘贴外部图片到md文件时，自动整理到附件文件夹下，方便整体发行及预览
	+ 修复非项目下的md文件预览时不能显示图片的bug
* 修复某些情况下，ctrl+f搜索会导致程序崩溃的问题
* 修复大量删除项目内文件可能会导致崩溃或项目列表清空的问题
* 【App插件】支持Mac真机运行同步文件
* 【App插件】新增manifest.json中（plus->arguments）配置应用默认启动参数功能
* 【App插件】新增toast的图标支持设置宽高（iconWidth/iconHeight）
* 【App插件】Android平台云端打包支持在manifest中指定targetSdkVersion版本（解决Google提交应用要求支持Android8.0+的问题）
* 【App插件】Android平台修复应用资源可能被清理工具删除的问题
* 【App插件】Android平台修复未配置震动权限时扫码成功引起应用崩溃的问题
* 【App插件】Android平台修复特定情况下状态栏高度计算不正确的问题
* 【App插件】Android平台修复二维码通过图片扫码识别（plus.barcode.scan）不触发回调的问题
* 【App插件】iOS平台修复自定义基座concole.log日志无法输出的问题
* 【App插件】iOS平台修复获取支付通道状态未及时更新的问题

## 0.1.43.20180625-alpha
* 修复内置浏览器、内置终端插件配置错误的问题
* 解决某些情况下编辑器右键"在项目管理器中定位"不生效的问题

## 0.1.42.20180623-alpha
* 【重要】新增内置终端【win: Alt+c；mac: Ctrl+c】
	+ 支持多终端
	+ 菜单运行支持解析package.json的命令直接运行到内置终端
* 优化代码块的自定义和显示
* 优化Vue2.x语法提示
* 插件外部命令支持保存自动执行，在插件配置中将"onDidSaveExecution": true, 重启生效。可用于保存时自动编译、压缩、提交svn等
* 优化格式化
* 修复粘贴时有时代码没有智能缩进的问题
* 解决外部命令运行有时会提示node异常的问题
* 调整代码助手数字选择默认策略为Alt+数字插入
* 【App插件】【重要】新增原生视频播放组件（支持flv、rtmp/hls/rtsp协议），新增直播推流组件（rtmp协议），规范参考 [http://www.html5plus.org/doc/zh_cn/video.html](http://www.html5plus.org/doc/zh_cn/video.html)
* 【App插件】【重要】直播开发指南，参见[http://ask.dcloud.net.cn/article/13416](http://ask.dcloud.net.cn/article/13416)
* 【App插件】解决wap2app打包原生时没有编译的问题
* 【App插件】Android平台修复高德定位使用缓存数据导致定位不准确的问题
* 【App插件】Android平台修复默认不支持媒体输入的问题
* 【App插件】Android平台修复Webview设置bottom属性横竖屏切换后可能不生效的问题
* 【App插件】iOS平台修复NView不能显示部分网络gif文件的问题
* 【App插件】iOS平台修复应用内支付（IAP）无法获取购买凭证的问题
* 【App插件】iOS平台修复无法直达支付宝的芝麻认证页面的问题
* 【云服务】云端打包校验应用属主权限，减少appid乱用，详见[http://ask.dcloud.net.cn/article/13413](http://ask.dcloud.net.cn/article/13413)

## 0.1.41.20180612-alpha
* 代码助手新增右侧详细信息
* 代码助手新增单击Alt切换数字插入状态的功能
* 新增中文输入免干扰功能，在特定语法区输入全角的分号逗号括号会自动替换为半角符号，减少错误，编写更顺畅。可在设置中配置开关
* 修复设置分栏为4宫格并关闭HBuilder X后，无法再次启动HBuilder X的问题
* 修复HTML文件不提示vue指令的问题
* 完善自定义代码块的帮助说明

##0.1.40.20180607-alpha
* 修复内置浏览器无法加载页面资源的问题
* 修复win10下浏览器运行-Edge提示找不到Edge浏览器的问题

##0.1.39.20180606-alpha
* 修复wxml的注释和智能选中的一些问题
* 修复某些情况下，格式化后滚动条位置不正确的问题

##0.1.38.20180605-alpha
* 紧急修复mac上部分文件格式化、外部命令菜单显示的若干bug

##0.1.37.20180605-alpha
* 新增内置浏览器预览，即老版的边改边看 【win: Alt+p；mac: Ctrl+p】
* 强化微信小程序支持，更好的小程序开发工具 [详见](http://ask.dcloud.net.cn/article/13373)
	+ 支持新建微信小程序项目、文件
	+ 支持小程序语法提示
	+ 支持直接运行到微信开发工具的模拟器看效果和调试【菜单运行】
* 新增自定义代码块功能【菜单工具-自定义代码块】
* 补充mui代码块
* 默认支持格式化vue文件，并修复格式化后光标位置不正确的问题
* 修复某些情况下中文输入法卡的问题
* 修复vue中url跳转失效的问题
* 修复有时代码块失效或变卡的问题
* 修复Mac版代码提示经常失效的问题
* 修复真机运行有时崩溃的问题
* 修复es6编译无效果的问题
* 修复js压缩插件不支持es6的问题
* 修复文件内搜索时输入中文有时候会崩溃的问题
* 修复Mac下运行项目下的npm命令失效的问题
* 修复选中内容按左边括号，无法在2端加括号包围的问题。只支持大中小括号，不包含尖括号
* 修复输入左边引号括号智能补齐匹配引号括号不支持多光标的问题

##0.1.36.20180521-alpha
* 修复 UniApp真机运行失败的问题
* 强化折叠，见菜单跳转
	+ 折叠单行【Alt+-】
	+ 展开单行【Alt+=】
	+ 折叠子行【Alt+Shift+-】
	+ 展开子行【Alt+Shift+=】
	+ 折叠所有行【Alt+Ctrl+Shift+-】
	+ 展开所有行【Alt+Ctrl+Shift+=】
	+ 折叠其他区域【Alt+Shift+o】
* 新增 选中当前行(不含首尾空白字符) 【鼠标双击行尾】【Ctrl+Shift+l】
* 智能双击强化 双击-、_、.这3个连字符，选中相连的词。例如class="mui-table-view mui-table-view-chevron"

## 0.1.35.20180519-alpha
* 紧急修复运行浏览器和真机的一些问题

## 0.1.34.20180519-alpha
* 【重要】新增App换量联盟，免费获得翻倍用户，[详见](http://ask.dcloud.net.cn/article/13300)
* 【重要】大幅强化vue，可能是最好的vue开发工具
* 优化less、scss语法提示
* 解析项目下package.json中npm命令，在运行和外部命令菜单提供快捷执行入口
* 优化浏览器运行的若干体验问题
* 配置语言类型关联，指定某后缀名文件使用某种语言编辑器打开（设置里files.associations节点）
* win版在根目录新增reset.bat，执行bat可清除HBuilderX所有数据配置
* 优化框架语法提示库的加载
* 优化插件部分体验问题
* 修复mac下外部命令shell模式无法打开终端的问题
* 优化文件保存无权限时的逻辑
* 智能双击新增选中折叠。鼠标双击折叠行前字符左侧可选中该折叠区域
* 优化扩大选区【Ctrl+=】
* markdown：新增markdown的浏览器运行预览【Ctrl+r】
* 【App插件】修复创建5+app项目后没有从服务器自动获取appid的问题
* 【App插件】优化manifest校验提示

## 0.1.33.20180505-alpha
* 新增插件管理
* 新增保存自动刷新浏览器功能（仅通过内置服务器打开的页面生效）
* 新增粘贴智能缩进，光标在行首缩进位置(不是顶格)时粘贴自动处理缩进
* 新增光标历史前进后退【Alt+←、Alt+→】及清空光标历史
* 支持拖拽标签卡到外部直接生成新窗体
* 分栏增加垂直分栏和四宫格模式
* 内置服务器首次启动策略修改为浏览器运行后启动，弹出权限询问框时请务必点允许
* 修改某些情况下格式化后光标错位的问题
* 修复新建窗体后项目管理器单击展开变双击的问题
* 新建项目时补充hello wap2app模板
* 优化酷黑主题的一些问题
* 修复文档结构图/大纲的中文兼容问题
* 修复临时文件标题不随着第一行内容变更的问题
* 优化HBuilderX文件目录结构，减少文件数量

## 0.1.32.20180424-alpha
* 新增Ctrl+鼠标右键移除点击位置的多光标/选区
* 新增js、css等分号结尾的语言中，双击分号选择该段内容的功能
* 修复酷黑主题搜索输入框字体颜色看不清的问题
* 修复某些情况下代码块不提示的问题
* 【App插件】修改某些情况下真机运行Uni-App/快应用时，修改单文件同步结果不正确的问题

## 0.1.31.20180420-alpha
* 新增文档结构图/大纲功能【Alt+w】（mac是Ctrl+w）
* 智能双击：HTML中新增双击=选中Tag属性、Css中新增双击类名左侧选中整个类、优化js中function等关键字双击末尾则选中该词
* 优化酷黑主题体验，修复nss,njs等文件酷黑主题下没有高亮的问题
* 新增Ctrl+鼠标滚轮缩放字体的开关配置项:editor.mouseWheelZoom
* 修复二进制文件预览的一些错误
* 修复某些情况下升级过慢的问题

## 0.1.30.20180418-alpha
* 新增黑色主题
* 新增编辑器分栏功能【Alt+Shift+1、Alt+Shift+2、Alt+Shift+3】
* 转到定义支持在另一分栏打开，方便并排查看【Ctrl+Alt+鼠标点击或Alt+Shift+D或windows下Shift+F12】
* 支持Alt+N将焦点移到编辑器的功能。至此完成：Alt+Q是左侧项目管理器，Alt+O是顶部工具栏，Alt+C是底部控制台，Alt+N是中间编辑器（mac下Alt改为Ctrl）
* 补充了mac下的文件复制移动删除等操作
* 增加历史剪切板【Ctrl+Alt+v】
* 优化搜索功能，搜不到的文字会变红，查找下一个循环到开头时会悬浮图标指示
* 在空白文档粘贴内容时，会自动检测待粘贴内容是否HTML或json，并自动切换语言类型和自动格式化
* 取消js文件保存时自动校验语法的默认设置，需要的开发者请手动在设置中调整jshint.onsave选项
* 修复某些情况tab缩进变成8的问题
* 修复某些情况重命名文件引发崩溃的问题
* 修复某些情况引号智能补全错乱的问题
* 修复某些情况JS跨文件转到定义不正确的问题
* 修复某些情况项目管理器目录层级错乱的问题
* 修复忘记密码后没有提示已发送邮件的问题
* 【App插件】Uni-App支持web组件引用本地html、js、css文件
* 【App插件】快应用/Uni-App真机运行基座升级到1.0.16

## 0.1.29.20180409-alpha
* 紧急更新某些情况下内置web服务器打开html显示404的问题
* 【App插件】小程序to快应用/Uni-App转换器增加最小版本描述，解决提交到快应用平台失败的问题

## 0.1.28.20180406-alpha
* 增加web服务器插件,仅支持HTML文件在浏览器运行时使用
* 文件夹内搜索添加全部替换的功能
* 修复未搜索到结果时，状态栏信息立即消失的问题
* 修复设置和搜索结果编辑器替换所有有时候未替换的问题
* 修复有时异常退出导致项目列表清空的问题
* 修复大文档在某些情况下折叠造成卡顿的问题
* 修复某些情况下大文档着色引发异常的问题
* 【mac版】解决finder里打开方式不能选择HbuilderX的问题
* 【mac版】修复部分快捷键失效的问题
* 【App插件】解决某些情况下，调试debug卡死的问题
* 【App插件】小程序to快应用/Uni-App转换器支持 url跳转参数传递,优化部分样式,组件转换
* 【App插件】快应用真机运行基座升级到1.0.15

##0.1.27.20180403-alpha
* 解决某些情况下App插件升级或安装失败的问题
* 解决某些情况下Mac版tab键失效的问题
* 【App插件】解决快应用/Uni-App真机运行时，修改部分文件提示编译失败的问题
* 【App插件】小程序to快应用/Uni-App转换器优化部分组件及样式转换，增加template的样式转换

## 0.1.26.20180401-alpha
*  搜索结果在状态栏增加提示
*  修复文件夹、项目无法重命名的问题
*  修复重命名文件时，如果该文件已打开，会打开两个标签卡的问题
*  修复某些情况下设置未成功保存的问题
*  修复某些语言文件在某些情况下的折叠异常问题
*  优化less、scss的着色，修复markdown某些字符导致的着色异常问题
*  Markdown：悬浮预览支持gif动画
* 【重要】【App插件】添加Uni-App/快应用打包Android apk的功能
* 【App插件】优化Uni-App/快应用调试流程，解决某些情况下调试器启动失败等问题
* 【App插件】小程序to快应用/Uni-App转换器优化import,template标签转换、修复部分样式转换问题
* 【App插件】快应用/Uni-App调试基座修复a标签点击不处理href、二维码扫描引起程序崩溃、video不居中显示等问题
* 【App插件】新建5+App时提供模板项目 

## 0.1.25.20180326-alpha
* 解决Mac无法浏览器运行的问题，并新增自动检测Chrome、Safari和FireFox
* 多光标模式支持上下移动行【Ctrl+Up/Down】、回车、反回车【Shift+Enter】等操作
* 添加Uni-App、快应用示例模板，新建项目时可选择
* 转义里新增了首字母大写，调整了大小写转换的快捷键【Alt+Shift+U/L/T】
* 修复搜索到折叠区域时，折叠不展开的bug
* 修复了代码助手在窗体右边缘时被遮挡、自闭合标签回车缩进错误等问题
* 修复了Mac版粘贴表格(numbers)内容到markdown文档时无法自动转换markdown表格的问题
* 【App插件】快应用真机运行基座升级到1.0.13
* 【App插件】更新小程序to快应用/Uni-App转换器
* 【重要】小程序to快应用/Uni-App转换器开源了！[GitHub地址](https://github.com/dcloudio/uni-migration)

## 0.1.24.20180323-alpha
* 控制台右键菜单增加复制
* 解决创建快应用项目目录结构不正确的问题
* 解决debug快应用或Uni-App后有时无法退出的问题
* 优化快应用调试
* 解决某些情况下真机运行无法启动的问题
* 解决真机运行/调试debug时，修改单个文件后，设备上显示白屏的问题
*【快应用开发插件】转换器修复部分样式不生效的问题

##0.1.23.20180320-alpha
* 【重要】新增快应用开发、运行、调试。[详见](http://quickapp.dcloud.io)
* 【重要】新增Uni-App开发、运行、调试。Uni-App是5+App的升级版，仍然支持5+webview，但界面主体由原生渲染引擎绘制。支持开发一次发布到更多平台。[详见](https://github.com/dcloudio/Uni-App)
* 【重要】新增微信小程序转换为快应用/Uni-App
* 【重要】新增mac版
* markdown：支持excel、wps、word、number中粘贴表格进来，自动转为markdown表格【特色】
* markdown：从内存中粘贴图片进md，自动创建md的附件文件夹（类似另存网页），将图片保存到文件夹并将链接展示到md中。保存md时，会自动清理无效图片【特色】
* markdown：鼠标移到图片语法区，悬浮显示本地图片。配套图片粘贴功能，进一步加强了对word、evernote的替代【特色】
* markdown：新增标题折叠【特色】
* markdown：修复了列复制无法按列粘贴的bug
* 补充了各种新语言的折叠
* 智能双击统一支持Ctrl添加新选区
* 智能双击新增双击选中HTML tag
* 新增HTML tag的包围和反包围【Ctrl+]】
* 新增HTML tag的起始、结束标签的套框指示
* 合并行支持多光标，支持去重空格【Ctrl+Shift+k】
* 优化了注释的体验，支持多光标注释
* 给选区首尾设置光标【Ctrl+\】。这样双击选中首尾tag或if块，按Ctrl+\，就可以把光标放到首尾，然后Ctrl+/就可以同时注释掉首行和尾行
* 根据语法选择相同词 【Ctrl+Shift+e】。传统的Ctrl+e选择相同词，在选择tag比如div时，会把子div也选中，而Ctrl+Shift+e则只会选中首尾的tag名称，方便一起改名
* 撤销最后一个多光标或选区【Ctrl+Shift+z】。用于最后一个光标或选区选错时，丢弃掉这个光标或选区
* 粘贴为HTML【Ctrl+Shift+v】可以在网页或excel里选内容，直接粘贴为HTML源码
* 优化转到定义【Alt+单击】
* 优化启动后代码提示引擎加载的速度
* js语法校验选项默认开启ES6
* 优化若干代码助手细节
* 运行浏览器时windows下自动检测chrome、firefox的路径，如果没有配置webserver地址就用file协议打开
* 自动修正常见的设置界面json语法错误
* 在快捷键设置界面新增HBuilderX快捷键的理念说明

## 0.1.22.20180302-alpha
* 新增若干语言的行注释【Ctrl+/】和块注释【Ctrl+shift+/】
* 新增if、for等关键字语法块包围【Ctrl+]】与反包围【Ctrl+Shift+]】
* 强化智能双击：双击if、for等选中函数块、双击注释选中注释块、双击行首空白选择相同缩进行
* 新增扩大选区【ctrl+=】，可连续扩大选区
* 复制行、删除行、剪切行，补充了多光标操作，大幅提升效率
* 新增互换2个选区或2行内容【Ctrl+shift+x】
* 新增去除行尾空格
* 优化了粘贴时自动缩进
* markdown：补充* 号无序列表【ctrl+alt+8】、+号无序列表【ctrl+alt+=】设置行首列表符的快捷键
* markdown：优化粘贴，自动生成url、图片等标签，自动过滤重复列表符
* markdown：支持格式化对齐表格【Ctrl+K】（暂未兼容不同字体和缩放条件变化）
* 解决大的js文件语法校验时卡顿的问题
* 解决修改软件路径导致文件关联失效的问题
* 解决文件内容过少导致无法正确获取编码的问题
* 解决纯净模式没有隐藏控制台的问题
* 优化文件夹内搜索

## 0.1.21.20180225-alpha
* 解决css提示内容不全的问题
* 解决jshint语法验证时，没有错误却弹出控制台的问题
* 解决有时HBuilderX退出时会报错的问题

## 0.1.20.20180212-alpha
* 新增App打包
* 新增js和json的语法校验
* 新增搜索分类、目录内搜索(Ctrl+Alt+F)
* 新增转到定义(F12)
* 新增纯净模式(双击标签卡)和免打扰模式(F11)
* 优化搜索菜单
* 新增块注释功能(Ctrl+Shift+/)
* 新增ejs、jade等前端模板语法高亮
* 新增为选区每行行首添加光标(Ctrl+Shift+\，也可以理解为Ctrl+|)
* 新增行首列表符设置：无序列表(Ctrl+Alt+-)，有序列表(Ctrl+Alt+1)，任务列表(Ctrl+Alt+1[)，已完成任务列表(Ctrl+Alt+])，并支持多光标设置
* 新增双击列表符-、*、+、[ ]、[x]，选中列表整段区域
* 新增双击#选中markdown标题段落
* [菜单-帮助-markdown语法帮助]中更新了操作技巧
* 解决配置文件包含中文可能导致视图菜单下的自动换行设置失败的问题
* 解决启动后项目管理器没有自动选中当前编辑器打开的文件的问题
* 解决markdown文件中删除空格有时会误删有序/无序列表符号的问题
祝大家新春快乐

## 0.1.17.20180122-alpha
* 【重要】需求墙上线了，喜欢HBuilder X的朋友们请移步[http://dev.dcloud.net.cn/wish/](http://dev.dcloud.net.cn/wish/)投票，提出你的想法
* 添加项目手动排序功能（通过鼠标拖动项目管理器里的项目上下移动）
* 添加项目管理器内文件拖拽移动功能
* 添加拖拽外部文件复制到项目管理器功能
* 解决高分屏下保存框字太大的问题
### App相关
* 【真机运行插件】解决真机运行手机失去连接后，保存代码有可能会导致崩溃的问题
* 【真机运行插件】解决某些情况下检测不到手机的问题
* 【真机运行插件】更新快应用调试基座

## 0.1.16.20180117-alpha
* 解决同名文件标签卡无法区分的问题
* 新建无标题文档并粘贴一段json后，文档格式将自动调整为json，同时格式化该文档
* 项目管理器里的文件，打开后HBuilderX标题栏显示其磁盘全路径url。
* 赞助者登录后，用户名处显示赞助信息

## 0.1.15.20180115-alpha
* 修复html文档中，tab不触发emmet的问题

## 0.1.14.20180112-alpha
* HBuilderX内测开始，欢迎大家使用。